{     .
     ,    (-,
-, ).
      .}

program p39n22;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

const
  eps = 1e-5;

type
  TTochka = record
    x,y: real;
  end;

var
  a,b,c: TTochka;
  ab,bc,ca,p,s,h1,h2,h3: real;
  flag: boolean;

begin
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);

  { }
  write ('   : ');
  readln (a.x,a.y);
  write ('   B: ');
  readln (b.x,b.y);
  write ('   C: ');
  readln (c.x,c.y);

  {  , }
  ab:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
  bc:=sqrt(sqr(b.x-c.x)+sqr(b.y-c.y));
  ca:=sqrt(sqr(c.x-a.x)+sqr(c.y-a.y));
  p:=(ab+bc+ca)/2;
  s:=sqrt(p*(p-ab)*(p-bc)*(p-ca));

  { }
  if s<eps
  then
    writeln ('    ')
  else
    begin
      write (' ');
      if (ab*ab+bc*bc-ca*ca < eps) or (ab*ab-bc*bc+ca*ca < eps) or (-ab*ab+bc*bc+ca*ca < eps)
      then
        writeln ('')
      else
        if (ab*ab+bc*bc < ca*ca) or (ab*ab+ca*ca < bc*bc) or (bc*bc+ca*ca < ab*ab)
        then
          writeln ('')
        else
          if (ab*ab+bc*bc > ca*ca) or (ab*ab+ca*ca > bc*bc) or (bc*bc+ca*ca > ab*ab)
          then
            writeln ('');

      { }
      h1:=2*s/ab;
      h2:=2*s/bc;
      h3:=2*s/ca;

      { }
      if h1>h2
      then
        if h2>h3
        then
          writeln (h1:0:3,' ',h2:0:3,' ',h3:0:3)
        else
          if h1>h3
          then
            writeln (h1:0:3,' ',h3:0:3,' ',h2:0:3)
          else
            writeln (h3:0:3,' ',h1:0:3,' ',h2:0:3)
      else
        if h3>h2
        then
          writeln (h3:0:3,' ',h2:0:3,' ',h1:0:3)
        else
          if h1>h3
          then
            writeln (h2:0:3,' ',h1:0:3,' ',h3:0:3)
          else
            writeln (h2:0:3,' ',h3:0:3,' ',h1:0:3)
    end;
  readln;
end.
